/*  Project laskuri
    jyu
    Copyright  1994. All Rights Reserved.

    SUBSYSTEM:    laskuri.exe Application
    FILE:         laskrapp.cpp
    AUTHOR:       vl


    OVERVIEW
    ========
    Source file for implementation of laskuriApp (TApplication).
*/


#include <owl\owlpch.h>
#pragma hdrstop


#include "laskrapp.h"
#include "lsktdlgc.h"                        // Definition of client class.       


//{{laskuriApp Implementation}}


//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(laskuriApp, TApplication)
//{{laskuriAppRSP_TBL_BEGIN}}
    EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
//{{laskuriAppRSP_TBL_END}}
END_RESPONSE_TABLE;


//////////////////////////////////////////////////////////
// laskuriApp
// =====
//
laskuriApp::laskuriApp () : TApplication("laskuri")
{

    // INSERT>> Your constructor code here.
}


laskuriApp::~laskuriApp ()
{
    // INSERT>> Your destructor code here.
}


//////////////////////////////////////////////////////////
// laskuriApp
// =====
// Application intialization.
//
void laskuriApp::InitMainWindow ()
{
    if (nCmdShow != SW_HIDE)
        nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

    SDIDecFrame *frame = new SDIDecFrame(0, GetName(), 0, false);
    frame->SetFlag(wfShrinkToClient);

    //
    // Assign ICON w/ this application.
    //
    frame->SetIcon(this, IDI_SDIAPPLICATION);


    SetMainWindow(frame);

}


//{{SDIDecFrame Implementation}}


SDIDecFrame::SDIDecFrame (TWindow *parent, const char far *title, TWindow *clientWnd, bool trackMenuSelection, TModule *module)
    : TDecoratedFrame(parent, title, clientWnd == 0 ? new laskuriTDLGClient(0) : clientWnd, trackMenuSelection, module)
{
    // INSERT>> Your constructor code here.

}


SDIDecFrame::~SDIDecFrame ()
{
    // INSERT>> Your destructor code here.

}


//////////////////////////////////////////////////////////
// laskuriApp
// ===========
// Menu Help About laskuri.exe command
void laskuriApp::CmHelpAbout ()
{
}
int OwlMain (int , char* [])
{
    try {
        laskuriApp    app;
        return app.Run();
    }
    catch (xmsg& x) {
        ::MessageBox(0, x.why().c_str(), "Exception", MB_OK);
    }

    return -1;
}
