/* FRIEND.CPP */

/* Esimerkiss tehdn funktiot, jotka kertovat mahtuuko
   ympyr nelin ja pinvastoin.  Jottei tehtvst tulisi
   liian matemaattista, tutkitaan vain olioden kokoja.
   Oikeasti mielekkmpi tehtv kertoisi leikkaavatko
   oliot toisiaan ja tllin tarvittaisiin tietysti
   mys keskipisteit
*/

#include <stdio.h>
#include <math.h>

class nelio; // Eteenpin viittaus jotta void. kyt. ympyrss

class ympyra{
  double r; // Sde
public:
  ympyra(double d=1.0) { r = d; }
  friend mahtuuko(const ympyra &y, const nelio &n);
  friend mahtuuko(const nelio &n, const ympyra &y);
  friend mahtuuko(const ympyra &y1, const ympyra &y2);
};

class nelio{
  double s; // Sivun pituus
public:
  nelio(double d=1.0) { s = d; }
  friend mahtuuko(const ympyra &y, const nelio &n);
  friend mahtuuko(const nelio &n, const ympyra &y);
  friend mahtuuko(const nelio &n1, const nelio &n2);
};


int mahtuuko(const ympyra &y, const nelio &n)
{
  return ( 2*y.r < n.s );
}

int mahtuuko(const nelio &n, const ympyra &y)
{
  return ( sqrt(2.0)*n.s/2 < y.r );
}

int mahtuuko(const ympyra &y1, const ympyra &y2)
{
  return ( y1.r < y2.r );
}

int mahtuuko(const nelio &n1,const nelio &n2)
{
  return ( n1.s < n2.s );
}

int main(void)
{
  nelio n1(2.1),n2(2.5); ympyra y1(0.9),y2(1.2);
  if ( mahtuuko(n1,y1) ) printf("Neli 1 mahtuu ympyrn 1 sislle.\n");
  if ( mahtuuko(y1,n1) ) printf("Ympyr 1 mahtuu nelin 1 sislle.\n");
  if ( mahtuuko(y1,y2) ) printf("Ympyrt mahtuvat siskkin.\n");
  if ( mahtuuko(n1,n2) ) printf("Nelit mahtuvat siskkin.\n");
  return 0;
}
