/* FRIEND2.CPP */

/* Esimerkiss tehdn funktiot, jotka kertovat mahtuuko
   ympyr nelin ja pinvastoin.
   Toteutus ystvluokan avulla.
*/

#include <iostream.h>
#include <math.h>

class nelio; // Eteenpin viittaus jotta void. kyt. ympyrss

class ympyra{
  friend nelio;
  double r; // Sde
public:
  ympyra(double d=1.0) { r = d; }
  int mahtuuko(const nelio &n) const;
  int mahtuuko(const ympyra &y2) const {
    return ( r < y2.r );
  }
};


class nelio{
  double s; // Sivun pituus
  friend ympyra;
public:
  nelio(double d=1.0) { s = d; }
  int mahtuuko(const ympyra &y) const {
    return ( sqrt(2.0)*s/2 < y.r );
  }
  int mahtuuko(const nelio &n2) {
    return ( s < n2.s );
  }
};


int ympyra::mahtuuko(const nelio &n) const
{
  return ( 2*r < n.s );
}


int main(void)
{
  nelio n1(2.1),n2(2.5); ympyra y1(0.9),y2(1.2);
  if ( n1.mahtuuko(y1) ) cout << "Neli 1 mahtuu ympyrn 1 sislle.\n";
  if ( y1.mahtuuko(n1) ) cout << "Ympyr 1 mahtuu nelin 1 sislle.\n";
  if ( y1.mahtuuko(y2) ) cout << "Ympyrt mahtuvat siskkin.\n";
  if ( n1.mahtuuko(n2) ) cout << "Nelit mahtuvat siskkin.\n";
  return 0;
}
