/* OPERATO2.CPP  - malli copy construktorin ja hvittjn tutkimiseen */
#include <stdio.h>
#include <string.h>
/*
   Kokeile seuraavia:

   1) Yhteenlaskussa on tilapinen muuttuja t
   2) ei ole tilapist muuttujaa t
   3) sijoitus on tyyppi piste &
   4) sijoitus on tyyppi piste
   5) sijoitus on tyyppi void
   6) yhteenlaskun parametri on tyyppi piste eik piste &
      palauta tmn jlkeen tyypiksi takaisin piste &
   7) lis pohjelmaan sijoitus p4 = p3 = p2 = p1
   8) edellinen ketjusijoitus sek sijoitus tyyppi piste
   9) kokeile viel kommentoida copy contructori pois kun
      tilapinen yhteenlaskumuuttuja on kytss.  Miten selitt
      tilanteen?

   Kuinka monta tilapist (ei itse mritelty) oliota syntyy
   kussakin tapauksessa + operaatiosta,  sijoitusoperaatiosta
   ja uhteens.  Eli normaalisti laskusta p4=p1+p2 kyttj
   olettaa 3 olion osallistuvan laskutoimitukseen.  Jos laskun
   aikana on esim. kytss 6 oliota, on nist yhteens
   3 "ylimrist" (joista 2 voi olla +:n takia ja 1 =:n takia).

   Tyt tuloksista alla oleva taulukko ja tee ptelm mik on
   paras tapa hoitaa sijoitus ja mik yhteenlasku.
   Ent jos laskuoperaatio on matriisilasku, jossa vlttmtt
   tarvitaan apumuuttuja?

   ----------------------------
   |  | p4=p1+p2  |p4=p1+p2+p3|
   |  | + | = |yht| + | = |yht|
   |--+---+---+---+---|---|---|
   |1)|   |   |   |   |   |   |
   |2)|   |   |   |   |   |   |
   |3)|   |   |   |   |   |   |
   |4)|   |   |   |   |   |   |
   |5)|   |   |   |   |   |   |
   |6)|   |   |   |   |   |   |
   |7)|   |   |   |   |   |   |
   |8)|   |   |   |   |   |   |
   |9)|   |   |   |   |   |   |
   ----------------------------

*/

class piste {
  int x,y;
  char nimi[20];
  static int pisteita;

public:
  piste() {x=0; y=0; nimea(); rivi("Empty constructor");  }
  piste(int ix,int iy,char *s="") {
    x = ix; y=iy; nimea(s);
    rivi("Norm.constructor");
  }
#if 1
  piste(piste &p) {
    x=p.x; y=p.y; nimea();
    rivi("Copy constructor","->",&p);
  }
#endif

  ~piste() {pisteita--; rivi("Hvittj","j"); }

  void nimea(char *s="") { // Oletuksena pisteiden mr + this -osoite
    pisteita++;
    if ( s[0] ) sprintf(nimi,"%02d-%s",pisteita,s);
    else sprintf(nimi,"%02d-%04p",pisteita,this);
  }

  void tulosta(int n=1) const {
    printf("(%d,%d) -- %-10.9s ",x,y,nimi); if (n) printf("\n");
  }

  void rivi(char *s,char *v="",piste *p=NULL) const {
    printf("%-20s : ",s);
    if ( p ) { p->tulosta(0); printf(" %-3s ",v); }
    tulosta(0);
    if ( v[0] == 'j' ) printf("  jljell %d",pisteita);
    else printf("%s%s%s",v,v,v);
    printf("\n");
  }

  piste operator+(piste &p);
  piste &operator=(piste &p);

};

piste piste::operator+(piste &p)
{
#if 1
  rivi("Yhteenlasku apum"," +",&p);

  piste t(0,0,"t");;

  t.x = x + p.x;
  t.y = y + p.y;
  return t;
#else
  rivi("Yhteenlasku ei apum"," +",&p);
  return piste( x + p.x, y+ p.y );
#endif
}


piste &piste::operator=(piste &p)
{
  rivi("Sijoitus","->",&p);

  x = p.x; y = p.y;
  return *this;
}


int piste::pisteita = 0;


int main(void)
{
  printf("---------------------------------------------------------------\n");
  piste p1(2,2,"p1"),p2(1,4,"p2"),p3(2,1,"p3"),p4(0,0,"p4");
  printf("p4 = p1 + p2:--------------------------------------------------\n");
  p4 = p1 + p2;
  printf("p4 = p1 + p2 + p3:---------------------------------------------\n");
  p4 = p1 + p2 +p3;
  printf("Ohjelman loppu:------------------------------------------------\n");
  return 0;
}

